import type {
  DepartmentChooseData,
  DepartmentItem
} from '@/types/DepartmentStore';
import { defineStore } from 'pinia';
import { ref } from 'vue';

export const useDepartment = defineStore('useDepartment', () => {
  const department = ref<DepartmentItem[]>([]);

  const lastVisit = ref<DepartmentItem>({
    deptCode: '',
    deptName: '',
    hospCode: '',
    deptTypeCode: '',
    deptTypeName: '',
    hospName: ''
  });
  const setDepartment = (data: DepartmentChooseData) => {
    department.value = data.bindDeptList;
    if (data.lastVisitDeptVO) {
      const target = data.bindDeptList.find(
        (item) => item.deptCode === data.lastVisitDeptVO.deptCode
      );

      if (target) {
        lastVisit.value = {
          deptCode: target.deptCode,
          deptName: target.deptName,
          hospCode: target.hospCode, // orgcode
          hospName: target.hospName,
          deptTypeCode: target.deptTypeCode,
          deptTypeName: target.deptTypeName
        };
      }
    } else {
      lastVisit.value = {
        deptCode: '',
        deptName: '',
        hospCode: '', // orgcode
        hospName: '',
        deptTypeCode: '',
        deptTypeName: ''
      };
    }

    // console.log(department.value)
  };

  // 设置科室
  const setLastVisitDept = (deptInfo: DepartmentItem) => {
    lastVisit.value = deptInfo;
  };

  const clearAllData = () => {
    department.value = [];
    lastVisit.value = {
      deptCode: '',
      deptName: '',
      hospCode: '',
      deptTypeCode: '',
      deptTypeName: '',
      hospName: ''
    };
  };

  return {
    department,
    setDepartment,
    clearAllData,
    lastVisit,
    setLastVisitDept
  };
});
